#####################################################################################
#
# Module: m25skirmishmode
# Author: m25
# 
# Description: Allow for team battles, buddy matches and watch mode within the FFvTTR Rumble Room
#
#
#
#####################################################################################

#3206
#m25: added proper prefixes to calls to m25team and m25ai

#print "Loading m25skirmish.py v.3.2.0 final; branch = m25 branch 1"

import js
from js import *
import sk
from sk import *
import m25ai
import m25missionover
import m25distance
import m25getset
import m25report
import cshelper
import ffx
from m25ai import *
from ffx import *
import m25event
import m25team

import chardata

#-------------------------------------------------------------------------------------
#
# Number of characters allowed in the skirmish.
#
#-------------------------------------------------------------------------------------
WATCH_MAXCHARS = 24

occupied = []
for i in range(WATCH_MAXCHARS):
	occupied.append(0)

allchars = []	
	
	
#-------------------------------------------------------------------------------------
#
# Callbacks
#
#-------------------------------------------------------------------------------------
	
def OnPostInit():
	#let the player see the entire level
	cshelper.see()
	# initialize the AI
	#m25ai.InitScripts() - commented out by DMC and moved to InitSkirmish
	#start up FFX
	ffx.FFX_InitSkirmish()
	# check for any characters that already exist on the map (put there by the map-maker)
	SetupPreexisting()
	# put the heroes on the appropriate teams (or set them as neutral if watch mode)
	SetupHeroTeam()
	# give the teams their orders
	SetupGroups()
	#monitor new enemies (eg private armies, spawning, minions etc)
	ffx.RegTimer('SkirmishNewEnemyCheck',1)

	

# def OnReceiveSelectedEnemies(enemies):
# 	sk.PreSetup()
# 	if not ('------------' in enemies):
# 		m25getset.SetMissionVar('currentteam',m25ai.TEAM_BADGUYS)
# 		m25getset.SetMissionVar('totalteams',2)
# 	for enemy in enemies:
# 		SkirmishSpawnEnemy(enemy)

# def OnSelectionRequiredCheck():
# 	return 1 #allows players to choose their opponents

# def OnNumEnemiesCheck():
# 	return WATCH_MAXCHARS

# def OnGameTypeCheck():
# 	#return ('skirmishspawn',)
#     return sk.GetStandardMarkerNames()

def OnNoMoreBadGuys():
	return
    
    
#call this from non M25 skirmish modes in the OnPostInit
def SetupFFXSkirmish(watch=0,hunt=1):
	print 'setupffx skirmish'
	#Its a skirmish! cross the entire map to get to the heroes!
	if hunt:
		m25ai.SetSkirmishModeOn()
	# initialize the AI
	m25ai.InitScripts()
	#launch FFX - initialising attributes and carriers etc
	ffx.FFX_InitSkirmish()
	# check for any characters that already exist on the map (put there by the map-maker)
	SetupPreexisting()
	# put the heroes on the appropriate teams (or set them as neutral if watch mode)
	SetupHeroTeam(watch=watch)
	# give the teams their orders
	SetupGroups()
	#monitor new enemies (eg private armies, spawning, minions etc)
	ffx.RegTimer('SkirmishNewEnemyCheck',1)    
    
    
#-------------------------------------------------------------------------------------
#
# Spawn the characters the player has selected
#
#-------------------------------------------------------------------------------------	
	

def SkirmishSpawnEnemy(template):
	if CheckSpecialCharacters(template):
		return ''
	massfactors = [1.0,3.0, 2.5, 1.25, 0.75, 1.0, 0, 1.5, 2.5, 1.5, 1.0]
	team = m25getset.GetMissionVar('currentteam',default=m25team.TEAM_BADGUYS,integer=1)
	name = GenerateName(template)
	loc = m25GetSpawnLoc(team)
	Object_SpawnAt(template, loc, name)
	chdata = chardata.GetCharacterData(name)
	if chdata.has_key('energy'):
		Object_SetAttr(name,'energy',chdata['energy'])
	if chdata.has_key('material') and chdata.has_key('mass'):
		Object_SetAttr(name,'mass',chdata['mass']*massfactors[int(chdata['material'])])
	print 'SkirmishSpawnEnemy: %s (%s, %d)' % (template,chardata.GetCharacterData(name).get('charName'),Object_GetAttr(name,'complex'))
	SkirmishSetUpEnemy(name)
	SkirmishSetupAI(name, team)
	return name

# def SkirmishSpawnEnemy(template):
# 	if CheckSpecialCharacters(template):
# 		return ''
# 	team = m25getset.GetMissionVar('currentteam',default=m25ai.TEAM_BADGUYS,integer=1)
# 	name = GenerateName(template)
# 	loc = m25GetSpawnLoc(team)
# 	Object_SpawnAt(template, loc, name)
# 	SkirmishSetUpEnemy(name)
# 	SkirmishSetupAI(name, team)
# 	return name

def SkirmishSetUpEnemy(name):
	# setup the custom AI
	#ffx.FFX_ObjectSetAttr(name,'skinit',1)
#	cshelper.regDeath(name,'SkirmishModeCheckEnd')
	allchars.append(name)
				
def CheckSpecialCharacters(template):
	team = m25getset.GetMissionVar('currentteam',default=m25team.TEAM_BADGUYS,integer=1)
	if template == '------------':
		#if (team != m25ai.TEAM_BADGUYS):
		m25getset.SetMissionVar('currentteam',team+1)
		m25getset.SetMissionVar('totalteams',team+1)
		m25team.SetTeamsNeutral(team+1,m25team.TEAM_NONCOMBATANT)
		m25getset.SetMissionVar('buddies',0)
		return 1
	if template == '---Buddies---':
		m25getset.SetMissionVar('buddies',1)
		return 1
	return 0
		
def GenerateName(template):
	total = m25getset.GetMissionVar('total',default=0,integer=1) + 1
	m25getset.SetMissionVar('total',total)
	return template + '_' + `total`
	
def m25GetSpawnLoc(team):
	if m25getset.GetMissionVar('buddies',default =0, integer=1):
		marker = 'skirmishspawn'
		pos = Get_MarkerPos(marker)
		loc  = (pos[0] + randint(-50,50), pos[1] + randint(-50,50), pos[2])
		return loc
	marker = m25getset.GetMissionVar('team'+`team`+'_marker',default=None)
	if marker == None:
		marker = sk.GetSpawnPoint(FindLoc())
		m25getset.SetMissionVar('team'+`team`+'_marker',marker)
	pos = Get_MarkerPos(marker)
	loc  = (pos[0] + randint(-50,50), pos[1] + randint(-50,50), pos[2])
	return loc

def FindLoc():
	total = len(occupied)-1
	i = randint(0,total)
	if occupied[i] == 1:
		found = 0
		while not (found==1):
			i = i + 1
			if i > total:
				i = 0
			if occupied[i] == 0:
				found = 1
	occupied[i] = 1
	return i+1

def SkirmishSetupAI(name,team):
	m25ai.SetupAI(name)
	if m25getset.GetMissionVar('buddies',default =0, integer=1):
		m25team.SetTeam(name,m25team.TEAM_GOODGUYS)
		m25ai.AddToGroup('team'+`m25team.TEAM_GOODGUYS`,name)
	else:
		m25team.SetTeam(name,team)
		m25ai.AddToGroup('team'+`team`,name)
	m25ai.SetBrawler(name)
	AI_SetAlerted(name, 1)
	ai = cshelper.findAI(name)
	ai.removeNaturalKillGoal()
	
		
#-------------------------------------------------------------------------------------
#
# Set up map characters
# check for any characters that already existed on the map and set them up as well
#
#-------------------------------------------------------------------------------------		
		
def SetupPreexisting():
	chars = js.Mission_GetDynamicObjects()
	for c in chars:
		m25ai.SetupCharacter(c)

#-------------------------------------------------------------------------------------
#
# Set up groups
# In this case, simple give the proper orders to the groups
#
#-------------------------------------------------------------------------------------
				
def SetupGroups():
	numteams = m25getset.GetMissionVar('totalteams',default=2,integer=1)
	team = m25team.TEAM_GOODGUYS
	while team <= numteams:
		if m25ai.GroupExists('team'+`team`):
			#m25ai.RegGroupLeaderKO('team'+`team`,'SkirmishLeaderKO')
			#m25ai.RegGroupMemberKO('team'+`team`,'SkirmishMemberKO')
			#m25ai.RegGroupPromoteLeader('team'+`team`,'SkirmishPromoteLeader')
			m25ai.RegGroupLeaderSet('team'+`team`,'SkirmishLeaderSet')
			#m25ai.RegGroupTimer('team'+`team`,'SkirmishTimer')
			m25ai.GroupCommand_HuntEnemies('team'+`team`)
			m25ai.GroupCommand_AllowCallsForHelp('team' + `team`)
			#m25ai.GroupCommand_SurroundEnemies('team'+`team`)
		team = team + 1
	


def SkirmishLeaderKO(groupname, leader):
	print groupname + ' leader koed'
	
def SkirmishMemberKO(groupname, member):
	print groupname + ' member koed'
	
def SkirmishPromoteLeader(groupname, value):
	print groupname + ' leader promotion in progress'
	
def SkirmishLeaderSet(groupname, value):
	print groupname + ' leader set'
	m25ai.GroupCommand_HuntEnemies(groupname)

def SkirmishTimer(groupname, value):
	print groupname + ' timer'

#-------------------------------------------------------------------------------------
#
# Set up heroes
# Put them on team 1 if physical
# or team 0 if non-physical (which creates a watch mode)
#
#-------------------------------------------------------------------------------------
	
	
def SetupHeroTeam(watch=0):
	if watch:
		m25ai.SetWatchMode()
	heroes = cshelper.getAllHeroes()
	for h in heroes:
		m25ai.SetupOneChar(h)
		if not watch:
			m25ai.AIDisableCustom(h) #make sure the computer doesn't take over for the player
			#m25ai.AIDisable(h)
		else:
			m25ai.AIEnableWatch(h)
			
		if Object_GetAttr(h,'physical') == 0:
			m25team.SetTeam(h, m25team.TEAM_NONCOMBATANT)
			m25ai.SetBrawler(h,0)
		else:
			m25team.SetTeam(h, m25team.TEAM_GOODGUYS)
			if watch:
				m25ai.SetBrawler(h,1)
			else:
				m25ai.SetBrawler(h,0)
#			cshelper.regDeath(h,'SkirmishModeCheckEnd')
			m25ai.AddToGroup('team'+`m25team.TEAM_GOODGUYS`,h)

			
#-------------------------------------------------------------------------------------
#
# Allow the player to turn the AI on and off for heroes
#
#-------------------------------------------------------------------------------------
			
def AddHeroAIToggles(default='off'):
	heroes = cshelper.getAllHeroes()
	for h in heroes:
		if not m25getset.GetObjectVar(h,'aitoggleon',default=0):
			print 'ADDing ai toggle for ' + h
			m25getset.SetObjectVar(h,'aitoggleon',1)
			if m25ai.IsAIDisabled(h):
				Mission_CustomAction('CUSTOM_TURNONAI','',h,'ToggleHeroAI',100,1)
			else:
				Mission_CustomAction('CUSTOM_TURNOFFAI','',h,'ToggleHeroAI',100,1)

def SetupHeroAIToggles():
	m25event.SetTimer(1,'HeroAITogglesEvent')		
				
def HeroAITogglesEvent(event):
	print 'CHECKING AI TOGGLES'
	AddHeroAIToggles()
	m25event.SetTimer(5,'HeroAITogglesEvent')
			
def ToggleHeroAI(target, char):
	if ffx.FFX_HasPortrait(target):
		if m25ai.IsAIDisabled(target):
			m25ai.AIEnable(target)
			m25ai.SetBrawler(target)
			Mission_CustomAction('CUSTOM_TURNOFFAI','',target,'ToggleHeroAI',100,1)
		else:
			m25ai.AIDisable(target)
			m25ai.SetBrawler(target,0)
			Mission_CustomAction('CUSTOM_TURNONAI','',target,'ToggleHeroAI',100,1)			


#-------------------------------------------------------------------------------------
#
# Periodically check for new characters
#
#-------------------------------------------------------------------------------------			
			
def SkirmishNewEnemyCheck(event):
	#print 'checking'
	ffx.RegTimer('SkirmishNewEnemyCheck',1)
	for char in Mission_GetDynamicObjects():
		if Object_GetClass(char)&ffx.FFX_CHARACTER:
			if ffx.FFX_ObjectGetAttr(char,'skinit')==0 and m25team.GetTeam(char)!=m25team.TEAM_GOODGUYS:
				print 'setting up %s'%(char)
				SkirmishSetupChar(char)

def SkirmishSetupChar(c):
	#if not IsAISet(c) and js.Object_GetAttr(c,'physical'):
	ffx.FFX_ObjectSetAttr(c,'skinit',1)
	if not m25team.IsTeamSet(c):
		m25ai.SetDefaultTeam(c)
	if m25team.GetTeam(c) != m25team.TEAM_NONCOMBATANT:
		m25ai.SetupAI(c)			
		m25ai.SetBrawler(c)
		if m25ai.InSkirmishMode():
			m25ai.AddGoal_HuntEnemy(c)
		AI_SetAlerted(c, 1)
		ai = cshelper.findAI(c)
		ai.removeNaturalKillGoal()				
			
#-------------------------------------------------------------------------------------
#
# End the skirmish with a cutscene
#
#-------------------------------------------------------------------------------------
			
def SkirmishModeCheckEnd(event):
	char = FindLivingTeam()
	if char != None:
		if FindEnemyTeam(char):
			regTimer('SkirmishModeCheckEnd',1)
			return
	regTimer('SkirmishCheckEndDelayed',4)
	#print 'MISSION OVER NOW!'
	#m25missionover.SetMissionOver()
	#m25ai.AIPeace()
	#lookcmd = "Camera_LookAtObject('" + char + "', -100, 0, 0, 3, CPM_SCROLLTO, CA_MOVE)"
	#gameover_cs[0][4] = lookcmd
	#play(gameover_cs, "gameover_cs", 1000)

def SkirmishCheckEndDelayed(event):
	char = FindLivingTeam()
	if char != None:
		if FindEnemyTeam(char):
			regTimer('SkirmishModeCheckEnd',1)
			return
	m25missionover.SetMissionOver()
	m25ai.AIPeace()
	lookcmd = "Camera_LookAtObject('" + char + "', -100, 0, 0, 3, CPM_SCROLLTO, CA_MOVE)"
	gameover_cs[0][4] = lookcmd
	play(gameover_cs, "gameover_cs", 1000)
	
def FindLivingTeam():
	chars = js.Mission_GetDynamicObjects()
	for c in chars:
		if Object_IsAlive(c) and (m25ai.GetTeam(c) != 0) and (not m25ai.ST_decoy(c)):
			return c
	return None
	
def FindEnemyTeam(char):
	chars = js.Mission_GetDynamicObjects()
	for c in chars:
		if Object_IsAlive(c) and m25team.AreEnemies(char, c):
			return 1
		team=m25ai.GetTeam(char)
		oldTeam=FFX_ObjectGetAttr(c,'targetOriginalTeam')
		if (Object_GetPrimaryState(char)==PCSTATE_HYPNOTISED) and (oldTeam != team):
			return 1
	return 0
		
gameover_cs = [
    [
        "Sound_PlayMusic('music_defeat', 1)",
        "see()",
        "peace()",
        "startCS()",
        "blank",
        "ff.m25missionover.SetMissionOver()",
        "wait(10)",
    ],
    [
        "endCS()",
        "playTransition()",
    ],
    [
        "Mission_Win()",
    ],
]		